<?php

namespace Drupal\jsonapi_schema\Normalizer;

/**
 * Data definition normalizer.
 */
class DataDefinitionBooleanNormalizer extends DataDefinitionNormalizer {

  /**
   * {@inheritdoc}
   */
  protected $supportedDataTypes = ['boolean'];

  /**
   * {@inheritdoc}
   */
  protected function allowedValues(array $context = []) {

    // Boolean fields implement OptionsProviderInterface, which would normally
    // cause oneOf/anyOf allowed values to be included. The JSON Schema
    // specification does not include these with boolean fields.
    // @see https://json-schema.org/understanding-json-schema/reference/boolean
    return [];
  }

}
